# Class ArithmeticInstruction

java.lang.Object
org.apache.bcel.generic.Instruction
org.apache.bcel.generic.ArithmeticInstruction

All Implemented Interfaces:
  `Cloneable, StackConsumer, StackProducer, TypedInstruction`

Direct Known Subclasses:
  `DADD, DDIV, DMUL, DNEG, DREM, DSUB, FADD, FDIV, FMUL, FNEG, FREM, FSUB, IADD, IAND, IDIV, IMUL, INEG, IOR, IREM, ISHL, ISHR, ISUB, IUSHR, IXOR, LADD, LAND, LDIV, LMUL, LNEG, LOR, LREM, LSHL, LSHR, LSUB, LUSHR, LXOR`

public abstract class ArithmeticInstruction extends Instruction implements TypedInstruction, StackProducer, StackConsumer
Super class for the family of arithmetic instructions.

- ## Field Summary

  ### Fields inherited from class Instruction

  `length, opcode`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ArithmeticInstruction(short opcode)`
  Constructs an ArithmeticInstruction.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Type`
  `getType(ConstantPoolGen cp)`
  Gets the type associated with this instruction.

  ### Methods inherited from class Instruction

  `accept, consumeStack, copy, dump, equals, getComparator, getLength, getName, getOpcode, hashCode, initFromFile, isValidByte, isValidShort, produceStack, readInstruction, setComparator, toString, toString, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface StackConsumer

  `consumeStack`

  ### Methods inherited from interface StackProducer

  `produceStack`

- ## Constructor Details

  - ### ArithmeticInstruction

    protected ArithmeticInstruction(short opcode)
    Constructs an ArithmeticInstruction.
    Parameters:
      `opcode` - of instruction.

- ## Method Details

  - ### getType

    public Type getType(ConstantPoolGen cp)
    Description copied from interface: `TypedInstruction`
    Gets the type associated with this instruction.
    Specified by:
      `getType` in interface `TypedInstruction`
    Parameters:
      `cp` - the constant pool generator.
    Returns:
      type associated with the instruction.